Index: /mods/wpsg_mod_downloadplus.class.php
===================================================================
--- /mods/wpsg_mod_downloadplus.class.php	(revision 7823)
+++ /mods/wpsg_mod_downloadplus.class.php	(revision 7824)
@@ -1190,518 +1484,515 @@
 						`".WPSG_TBL_PDFINDIV."`
 					WHERE
-						DATE_ADD(`done`, INTERVAL ".$this->shop->get_option('wpsg_mod_downloadplus_cleanolddownloads')." DAY) < NOW()
-				"));
-
-        }
-
-        if (wpsg_isSizedArray($arClean))
-        {
-
-            foreach ($arClean as $c)
-            {
-
-                $path = $this->getPDFIndivPath($c['o_id']);
-
-                unlink($path.'/'.$c['out_file']);
-
-                $this->db->Query("DELETE FROM `".WPSG_TBL_PDFINDIV."` WHERE `id` = '".wpsg_q($c['id'])."'");
+						`o_id` = '".wpsg_q($order_id)."' AND
+						`done` != '0000-00-00 00:00:00'
+				");
+
+	        foreach ($this->shop->view['arPDFs'] as $k => $v)
+	        {
+
+	            // Download noch gÃŒltig
+	            if ($this->shop->get_option('wpsg_mod_downloadplus_accepted') == '1' && $v['counter'] >= $this->shop->get_option('wpsg_mod_downloadplus_downloads'))
+	            {
+	                unset($this->shop->view['arPDFs'][$k]);
+	            }
+	            else if ($this->shop->get_option('wpsg_mod_downloadplus_accepted') == '2' && time() > (strtotime($v['done']) + ($this->shop->get_option('wpsg_mod_downloadplus_days') * 86400)))
+	            {
+	                unset($this->shop->view['arPDFs'][$k]);
+	            }
+	            else
+	            {
+	                $this->shop->view['arPDFs'][$k]['hash'] = $this->makeHash($v['id']);
+	            }
+
+	        }
+
+	        if (sizeof($this->shop->view['arPDFs']) > 0)
+	        {
+
+	            $this->shop->view['order'] = $this->shop->cache->loadOrder($order_id);
+	            $this->shop->view['kunde'] = $this->shop->cache->loadKunden($this->shop->view['order']['k_id']);
+
+	            // Andere Sprache setzten wenn die Bestellung in einer anderen Sprache durchgefÃŒhrt wurde
+	            if (trim($this->shop->view['order']['language']) != '') $this->shop->setTempLocale($this->shop->view['order']['language']);
+
+	            $mail_text = $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_downloadplus/pdfdownloadmail.phtml', false);
+
+	            if ($this->shop->get_option('wpsg_htmlmail') === '1')
+	            {
+
+	                $mail_html = $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_downloadplus/pdfdownloadmail_html.phtml', false);
+
+	            }
+	            else
+	            {
+
+	                $mail_html = false;
+
+	            }
+
+	            $attachment = array();
+
+	            if ($this->shop->get_option('wpsg_mod_downloadplus_attachement') == '1')
+	            {
+
+	                foreach ($this->shop->view['arPDFs'] as $k => $v)
+	                {
+
+	                    $attachment[] = $this->getPDFIndivPath($order_id).'/'.$v['out_file'];
+
+	                }
+
+	            }
+
+	            $this->shop->sendMail($mail_text, $this->shop->view['kunde']['email'], 'pdfdownloadfiles', $attachment, $order_id, false, $mail_html);
+
+	            $this->shop->restoreTempLocale();
+
+	            $this->db->ImportQuery(WPSG_TBL_OL, array(
+	                "o_id" => wpsg_q($order_id),
+	                "cdate" => "NOW()",
+	                "title" => wpsg_translate(__('Pdf Downloads an:#1#', 'wpsg'), $this->shop->view['kunde']['email']),
+	                "mailtext" => wpsg_q($mail_text)
+	            ));
+
+	            $this->arMessage[] = __('E-Mail erfolgreich gesendet.', 'wpsg');
+
+	        }
+	        else
+	        {
+
+	            $this->arError[] = __('Keine gÃŒltigen Downloads.', 'wpsg');
+
+	        }
+
+	    } // public function sendFiles($order_id)
+
+	    /**
+	     * Individualisiert die PDFs fÃŒr eine Bestellung
+	     */
+	    public function indivOrder($order_id) {
+
+	        $arBasket = $this->shop->cache->loadBasketArray($order_id);
+
+	        $bPDFProdukt = false;
+	        $arPDF = array();
+
+	        $oOrder = wpsg_order::getInstance($order_id);
+
+	        foreach ($oOrder->getOrderProducts() as $oOrderProduct) {
+
+	        	if ($this->isPDFProdukt($oOrderProduct->getProductKey())) {
+
+	        		$oProduct = $oOrderProduct->getProduct();
+	        		$bPDFProdukt = true;
+	        		$product_files = $this->getFiles($oOrderProduct->getProductKey());
+
+	        		foreach ($product_files as $file) {
+
+	        			$arPDF[] = array(
+	                        $oOrderProduct->getProductKey(), $file, $oOrderProduct->getProductIndex(),
+		                    'mode' => $oProduct->getMeta('mod_downloadplus_mode'),
+		                    'template' => $this->getTemplateIdFromProduct($oOrderProduct->getProductKey())
+	                    );
+
+			        }
+
+		        }
+
+	        }
+
+	        if ($bPDFProdukt === true && wpsg_isSizedArray($arPDF)) {
+
+	            foreach ($arPDF as $v) {
+
+	                $this->db->Query("DELETE FROM `".WPSG_TBL_PDFINDIV."` WHERE `file` = '".wpsg_q($v[1])."' AND `o_id` = '".wpsg_q($order_id)."' AND `p_key` = '".wpsg_q($v[0])."' AND `product_index` = '".wpsg_q($v[2])."' ");
+
+	                $download_nr = $this->getDownloadNr($order_id, $v[0], $v[2]);
+
+	                $this->db->ImportQuery(WPSG_TBL_PDFINDIV, array(
+	                    "o_id" => wpsg_q($order_id),
+	                    "downloadnr" => wpsg_q($download_nr),
+	                    "p_key" => wpsg_q($v[0]),
+	                    'product_index' => wpsg_q($v[2]),
+	                    "downloadnr" => wpsg_q($download_nr),
+	                    "file" => wpsg_q($v[1]),
+	                    "scheduled" => wpsg_q("NOW()"),
+	                    "done" => wpsg_q("0000-00-00 00:00:00"),
+	                    "out_file" => wpsg_q($this->getNewName($v[1], $order_id, $v[0], $download_nr, $v[2])),
+		                'mode' => $v['mode'],
+		                'template' => $v['template']
+	                ));
+
+	            }
+
+	        }
+
+	    } // public function indivOrder($order_id)
+
+	    /**
+	     * Gibt den Individualisierten Dateinamen fÃŒr ein File und Bestellung zurÃŒck
+	     */
+	    public function getNewName($oldFilename, $order_id, $product_key, $download_nr, $product_index)
+	    {
+
+	        $product_id = $this->shop->getProduktId($product_key);
+
+	        $arReplace = array(
+	            '/%filename%/i' => $oldFilename,
+	            '/%filename_clear%/i' => preg_replace('/\.(.*)$/', '', $oldFilename),
+	            '/%filename_ohneext%/i' => preg_replace('/\.(.*)$/', '', $oldFilename),
+	            '/%download_nr%/i' => $download_nr
+	        );
+
+	        $newFilename = $this->shop->replaceUniversalPlatzhalter($this->shop->get_option('wpsg_mod_downloadplus_filename'), $order_id, false, false, $product_id, $arReplace, $product_index);
+
+	        return $newFilename;
+
+	    } // public function getNewName($oldFilename, $order_id, $product_key, $download_nr, $product_index)
+
+	    /**
+	     * Gibt die PDFdateien eines Produktes zurÃŒck
+	     */
+	    public function getFiles($produkt_key, $ignoreTemplateFiles = false) {
+
+	        $product_id = $this->shop->getProduktID($produkt_key); $oProduct = wpsg_product::getInstance($product_id);
+			$arPDFFiles = [];
+
+	        if (!$ignoreTemplateFiles && $oProduct->getMeta('mod_downloadplus_mode') === '1') {
+
+	        	$template_id = $this->getTemplateIdFromProduct($produkt_key);
+	        	$template = $this->getTemplate($template_id)[0];
+
+	        	$path = $this->getPDFTemplatePath($template['id']);
+
+	        	if (wpsg_isSizedString($template['file']) && file_exists($path.$template['file'])) {
+
+	        		$arPDFFiles[] = $template['file'];
+
+		        }
+
+	        } else {
+
+		        $path = $this->getPDFPath($product_id);
+
+		        if (!file_exists($path)) return;
+
+		        $arrFiles = scandir($path);
+
+		        foreach ($arrFiles as $file) {
+
+		            if (is_file($path.$file) && in_array(strtolower(preg_replace('/(.*)\./', '', $file)), $this->valid_ending)) {
+
+		                $arPDFFiles[] = $file;
+
+		            }
+
+		        }
+
+	        }
+
+	        return $arPDFFiles;
+
+	    } // private function getFiles($produkt_id)
+
+	    /**
+	     * Gibt alle Dokumente zurÃŒck, die zu einer Bestellung individualisiert wurden
+	     */
+	    public function getIndivFiles($produkt_id, $order_id)
+	    {
+
+	        $produkt_id = $this->shop->getProduktID($produkt_id);
+
+	        $arFilesProdukt = $this->getFiles($produkt_id);
+	        $arFilesReturn = array();
+
+	        foreach ($arFilesProdukt as $k => $v)
+	        {
+
+	            $indiv = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_PDFINDIV."` WHERE `o_id` = '".wpsg_q($order_id)."' AND `file` = '".wpsg_q($v)."'");
+
+	            $infoArray = array(
+	                'done' => '0000-00-00 00:00:00',
+	                'scheduled' => '0000-00-00 00:00:00',
+	                'counter' => -1,
+	                'status' => 0
+	            );
+
+	            if ($indiv['id'] > 0)
+	            {
+
+	                $infoArray['status'] = 1;
+	                $infoArray['done'] = $indiv['done'];
+	                $infoArray['scheduled'] = $indiv['scheduled'];
+	                $infoArray['counter'] = $indiv['counter'];
+	                $infoArray['indiv_id'] = $indiv['id'];
+	                $infoArray['hash'] = $this->makeHash($indiv['id']);
+
+	            }
+
+	            if (@strtotime($indiv['done']) > 0) $infoArray['status'] = 2;
+
+	            $infoArray['file'] = $v;
+	            $infoArray['file_out'] = @$indiv['out_file'];
+	            $infoArray['path'] = $this->getPDFIndivPath($order_id);
+
+	            $arFilesReturn[] = $infoArray;
+
+	        }
+
+	        return $arFilesReturn;
+
+	    } // public function getIndivFiles($produkt_id, $order_id)
+
+	    /**
+	     * ÃberprÃŒft ein Produkt ob es ein PDFDownloadProdukt ist
+	     */
+	    public function isPDFProdukt($produkt_key) {
+
+	    	$oProduct = wpsg_product::getInstance($this->shop->getProduktID($produkt_key));
+	        $arPDFs = $this->getFiles($produkt_key);
+
+	        if (sizeof($arPDFs) > 0 || $oProduct->getMeta('mod_downloadplus_set') === '1') return true;
+
+	        return false;
+
+	    } // private function isPDFProdukt($produkt_key)
+
+	    /**
+	     * Gibt den Pfad zu dem Ordner zurÃŒck in dem die PDFs abgelegt werden
+	     */
+	    public function getPDFPath($produkt_id)
+	    {
+
+	        if ($this->shop->get_option('wpsg_mod_downloadplus_pdfpath') !== false && trim($this->shop->get_option('wpsg_mod_downloadplus_pdfpath')) != '')
+	        {
+
+	            $path = $this->shop->get_option('wpsg_mod_downloadplus_pdfpath').'/'.$produkt_id.'/';
+
+	        }
+	        else
+	        {
+
+	            if ($this->shop->isMultiBlog())
+	            {
+
+	                $path = WP_CONTENT_DIR.'/'.WPSG_MB_UPLOADS.'/wpsg/wpsg_pdfprodukte/'.$produkt_id.'/';
+
+	            }
+	            else
+	            {
+
+	                $path = WP_CONTENT_DIR.'/uploads/wpsg/wpsg_pdfprodukte/'.$produkt_id.'/';
+
+	            }
+
+	        }
+
+	        $this->shop->protectDirectory($path);
+
+	        return $path;
+
+	    } // public function getPDFPath($produkt_id)
+
+	    /**
+	     * Gibt den Pfad zurÃŒck wo die Individualisierten PDFs einer Bestellung liegen
+	     */
+	    public function getPDFIndivPath($order_id) {
+
+	        if ($this->shop->get_option('wpsg_mod_downloadplus_pdfindivpath') !== false && trim($this->shop->get_option('wpsg_mod_downloadplus_pdfindivpath')) != '') {
+
+	            $path = $this->shop->get_option('wpsg_mod_downloadplus_pdfindivpath').'/'.$order_id.'/';
+
+	        } else {
+
+	            if ($this->shop->isMultiBlog()) {
+
+	                $path = WP_CONTENT_DIR.'/'.WPSG_MB_UPLOADS.'/wpsg/wpsg_pdfprodukte_order/'.$order_id.'/';
+
+	            } else {
+
+	                $path = WP_CONTENT_DIR.'/uploads/wpsg/wpsg_pdfprodukte_order/'.$order_id.'/';
+
+	            }
+
+	        }
+
+	        $this->shop->protectDirectory($path);
+
+	        return $path;
+
+	    } // public function getPDFIndivPath($order_id)
+
+		/**
+		 * Gibt den Pfad zurÃŒck, wo die Datei des Templates abgelegt wird
+		 * @param $template_id
+		 */
+		public function getPDFTemplatePath($template_id) {
+
+			$template_id = intval($template_id);
+
+		    if ($this->shop->isMultiBlog()) {
+
+                $path = WP_CONTENT_DIR.'/'.WPSG_MB_UPLOADS.'/wpsg/wpsg_dp_templatefiles/'.$template_id.'/';
+
+            } else {
+
+                $path = WP_CONTENT_DIR.'/uploads/wpsg/wpsg_dp_templatefiles/'.$template_id.'/';
 
             }
 
-        }
-
-        if (wpsg_isSizedArray($arLog))
-        {
-
-            $this->shop->view['arOrder'] = $arLog;
-
-            foreach ($this->shop->view['arOrder'] as $k => $v)
-            {
-
-                $order = $this->shop->cache->loadOrder($k);
-
-                $this->shop->view['arOrder'][$k] = array($v, $order, md5($order['cdate'].'wpsg'.$order['id']));
-
-                if ($this->shop->get_option('wpsg_mod_downloadplus_autosend') == '1')
-                {
-
-                    $this->sendFiles($order['id']);
-
-                }
-
-            }
-
-            $mail_text = $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_downloadplus/cronmail.phtml', false);
-
-            if ($this->shop->get_option('wpsg_htmlmail') === '1')
-            {
-
-                $mail_html = $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_downloadplus/cronmail_html.phtml', false);
-
-            }
-            else
-            {
-
-                $mail_html = false;
-
-            }
-
-            $this->shop->sendMail($mail_text, $this->shop->get_option('wpsg_pdfdownloadcronmail_empfaenger'), 'pdfdownloadcronmail', array(), false, false, $mail_html);
-
-        }
-
-    } // public function cron()
-
-    public function wpsg_mod_export_loadFields(&$arFields)
-    {
-
-        $arDPFields = array(
-            'name' => __('Downloadplus', 'wpsg'),
-            'fields' => array()
-        );
-
-        for ($i = 1; $i <= 10; $i ++)
-        {
-
-            $arDPFields['fields']['text'.$i] = wpsg_translate(__('Text in Textfeld #1#', 'wpsg'), $i);
-
-        }
-
-        $arDPFields['fields']['dnr'] = __('Downloadnummer', 'wpsg');
-
-        $arFields[] = $arDPFields;
-
-    } // public function wpsg_mod_export_loadFields(&$arFields)
-
-    public function wpsg_mod_export_getValue(&$return, $field_value, $o_id, $p_id, $productkey, $product_index, $profil_separator)
-    {
-
-        // Individualisierung heraussuchen
-        $db_indiv = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_PDFINDIV."` WHERE `o_id` = '".wpsg_q($o_id)."' AND `p_key` = '".wpsg_q($p_id)."' AND `product_index` = '".wpsg_q($product_index)."' ORDER BY `id` DESC LIMIT 1 ");
-
-        switch ($field_value)
-        {
-
-            case 'dnr':
-                if (!wpsg_isSizedInt($db_indiv['id'])) $return = ''; else $return = $db_indiv['downloadnr'];
-                break;
-
-            default:
-
-                if (preg_match('/^text\d+$/', $field_value))
-                {
-
-                    $return = '';
-
-                    if (wpsg_isSizedInt($db_indiv['id']))
-                    {
-
-                        $arTexte = unserialize($db_indiv['fielddata']);
-
-                        if (wpsg_isSizedArray($arTexte))
-                        {
-
-                            $txt_nr = substr($field_value, 4);
-
-                            $return = $arTexte['texte'][$txt_nr - 1];
-
-                        }
-
-                    }
-
-                }
-
-        } // switch
-
-    } // public function wpsg_mod_export_getValue(&$return, $field_value, $o_id, $p_id, $product_index, $profil_separator)
-
-    /**
-     * Baut den Kontroll Hash
-     */
-    private function makeHash($indiv_id)
-    {
-
-        $indiv_db = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_PDFINDIV."` WHERE `id` = '".wpsg_q($indiv_id)."'");
-        if ($indiv_db['id'] <= 0) return false;
-
-        $order = $this->shop->cache->loadOrder($indiv_db['o_id']);
-        if ($order['id'] <= 0) return false;
-
-        $strHash = md5($order['cdate'].'wpsg'.$indiv_db['file']);
-
-        return $strHash;
-
-    } // private function makeHash($indiv_id)
-
-    /**
-     * Sendet die Mail mit den Downloadlinks an den Kunden
-     */
-    public function sendFiles($order_id)
-    {
-
-        $this->shop->view['arPDFs'] = $this->db->fetchAssoc("
+		    if (!file_exists($path)) mkdir($path, 0775, true);
+
+	        return $path;
+
+		}
+
+	    /**
+	     * Gibt die DownloadNr zurÃŒck
+	     * @param int $order_id BestellID
+	     * @param varchar $product_key Produktkey
+	     */
+	    private function getDownloadNr($order_id, $product_key, $product_index)
+	    {
+
+	        $product_id = $this->shop->getProduktID($product_key);
+
+	        $format = $this->shop->get_option('wpsg_mod_downloadplus_numberformat');
+	        if (!wpsg_isSizedString($format)) $format = "%download_nr%";
+
+	        $download_nr = $this->shop->get_option('wpsg_mod_downloadplus_startnumber');
+	        if (!wpsg_isSizedInt($download_nr)) $download_nr = 1;
+
+	        $arCustomReplace = array(
+	            '/\%download_nr\%/i' => $download_nr
+	        );
+
+	        $format = $this->shop->replaceUniversalPlatzhalter($format, $order_id, false, false, $product_id, $arCustomReplace, $product_index);
+
+	        $this->shop->update_option('wpsg_mod_downloadplus_startnumber', $download_nr + 1);
+
+	        return $format;
+
+	    } // private function getDownloadNr($order_id, $product_key)
+
+		/**
+		 * Gibt einen Array mit Templates zurÃŒck, wird $template_id ÃŒbergeben, so wird nur das Template mit dieser ID geladen
+		 * @param $template_id
+		 */
+		public function getTemplate($template_id = null) {
+
+			$strQueryWHERE = " T.`deleted` != '1' ";
+
+			if (wpsg_isSizedInt($template_id)) {
+
+				$strQueryWHERE .= " AND T.`id` = '".wpsg_q($template_id)."' ";
+
+			}
+
+			$arTemplates = $this->db->fetchAssoc("
 				SELECT
-					*
-				FROM
-					`".WPSG_TBL_PDFINDIV."`
+					T.*
+				FROM	
+					`".WPSG_TBL_DP_TEMPLATES."` AS T
 				WHERE
-					`o_id` = '".wpsg_q($order_id)."' AND
-					`done` != '0000-00-00 00:00:00'
+					".$strQueryWHERE."
 			");
 
-        foreach ($this->shop->view['arPDFs'] as $k => $v)
-        {
-
-            // Download noch gÃŒltig
-            if ($this->shop->get_option('wpsg_mod_downloadplus_accepted') == '1' && $v['counter'] >= $this->shop->get_option('wpsg_mod_downloadplus_downloads'))
-            {
-                unset($this->shop->view['arPDFs'][$k]);
-            }
-            else if ($this->shop->get_option('wpsg_mod_downloadplus_accepted') == '2' && time() > (strtotime($v['done']) + ($this->shop->get_option('wpsg_mod_downloadplus_days') * 86400)))
-            {
-                unset($this->shop->view['arPDFs'][$k]);
-            }
-            else
-            {
-                $this->shop->view['arPDFs'][$k]['hash'] = $this->makeHash($v['id']);
-            }
-
-        }
-
-        if (sizeof($this->shop->view['arPDFs']) > 0)
-        {
-
-            $this->shop->view['order'] = $this->shop->cache->loadOrder($order_id);
-            $this->shop->view['kunde'] = $this->shop->cache->loadKunden($this->shop->view['order']['k_id']);
-
-            // Andere Sprache setzten wenn die Bestellung in einer anderen Sprache durchgefÃŒhrt wurde
-            if (trim($this->shop->view['order']['language']) != '') $this->shop->setTempLocale($this->shop->view['order']['language']);
-
-            $mail_text = $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_downloadplus/pdfdownloadmail.phtml', false);
-
-            if ($this->shop->get_option('wpsg_htmlmail') === '1')
-            {
-
-                $mail_html = $this->shop->render(WPSG_PATH_VIEW.'/mods/mod_downloadplus/pdfdownloadmail_html.phtml', false);
-
-            }
-            else
-            {
-
-                $mail_html = false;
-
-            }
-
-            $attachment = array();
-
-            if ($this->shop->get_option('wpsg_mod_downloadplus_attachement') == '1')
-            {
-
-                foreach ($this->shop->view['arPDFs'] as $k => $v)
-                {
-
-                    $attachment[] = $this->getPDFIndivPath($order_id).'/'.$v['out_file'];
-
-                }
-
-            }
-
-            $this->shop->sendMail($mail_text, $this->shop->view['kunde']['email'], 'pdfdownloadfiles', $attachment, $order_id, false, $mail_html);
-
-            $this->shop->restoreTempLocale();
-
-            $this->db->ImportQuery(WPSG_TBL_OL, array(
-                "o_id" => wpsg_q($order_id),
-                "cdate" => "NOW()",
-                "title" => wpsg_translate(__('Pdf Downloads an:#1#', 'wpsg'), $this->shop->view['kunde']['email']),
-                "mailtext" => wpsg_q($mail_text)
-            ));
-
-            $this->arMessage[] = __('E-Mail erfolgreich gesendet.', 'wpsg');
-
-        }
-        else
-        {
-
-            $this->arError[] = __('Keine gÃŒltigen Downloads.', 'wpsg');
-
-        }
-
-    } // public function sendFiles($order_id)
-
-    /**
-     * Individualisiert die PDFs fÃŒr eine Bestellung
-     */
-    public function indivOrder($order_id) {
-
-        $arBasket = $this->shop->cache->loadBasketArray($order_id);
-
-        $bPDFProdukt = false;
-        $arPDF = array();
-
-        foreach ($arBasket['produkte'] as $p) {
-			
-            if ($this->isPDFProdukt($p['id'])) {
-
-                $bPDFProdukt = true;
-
-                // Hier darf nicht wpsg_array_merge verwendet werden, da sonst Index=0 ÃŒberschrieben wird
-                //$arPDF = array_merge($arPDF, $this->getFiles($p['id']));						
-
-                if (wpsg_isSizedString($p['mod_vp_varkey'])) $product_key = $p['mod_vp_varkey']; else $product_key = $p['productkey'];
-
-                $product_files = $this->getFiles($p['id']);
-
-                foreach ($product_files as $file) {
-
-                    $arPDF[] = array(
-                        $product_key, $file, $p['product_index']
-                    );
-
-                }
-
-            }
-
-        }
-
-        if ($bPDFProdukt === true && wpsg_isSizedArray($arPDF))
-        {
-
-            foreach ($arPDF as $v)
-            {
-
-                $this->db->Query("DELETE FROM `".WPSG_TBL_PDFINDIV."` WHERE `file` = '".wpsg_q($v[1])."' AND `o_id` = '".wpsg_q($order_id)."' AND `p_key` = '".wpsg_q($v[0])."' AND `product_index` = '".wpsg_q($v[2])."' ");
-
-                $download_nr = $this->getDownloadNr($order_id, $v[0], $v[2]);
-
-                $this->db->ImportQuery(WPSG_TBL_PDFINDIV, array(
-                    "o_id" => wpsg_q($order_id),
-                    "downloadnr" => wpsg_q($download_nr),
-                    "p_key" => wpsg_q($v[0]),
-                    'product_index' => wpsg_q($v[2]),
-                    "downloadnr" => wpsg_q($download_nr),
-                    "file" => wpsg_q($v[1]),
-                    "scheduled" => wpsg_q("NOW()"),
-                    "done" => wpsg_q("0000-00-00 00:00:00"),
-                    "out_file" => wpsg_q($this->getNewName($v[1], $order_id, $v[0], $download_nr, $v[2]))
-                ));
-
-            }
-
-        }
-
-    } // public function indivOrder($order_id)
-
-    /**
-     * Gibt den Individualisierten Dateinamen fÃŒr ein File und Bestellung zurÃŒck
-     */
-    public function getNewName($oldFilename, $order_id, $product_key, $download_nr, $product_index)
-    {
-
-        $product_id = $this->shop->getProduktId($product_key);
-
-        $arReplace = array(
-            '/%filename%/i' => $oldFilename,
-            '/%filename_clear%/i' => preg_replace('/\.(.*)$/', '', $oldFilename),
-            '/%filename_ohneext%/i' => preg_replace('/\.(.*)$/', '', $oldFilename),
-            '/%download_nr%/i' => $download_nr
-        );
-
-        $newFilename = $this->shop->replaceUniversalPlatzhalter($this->shop->get_option('wpsg_mod_downloadplus_filename'), $order_id, false, false, $product_id, $arReplace, $product_index);
-
-        return $newFilename;
-
-    } // public function getNewName($oldFilename, $order_id, $product_key, $download_nr, $product_index)
-
-    /**
-     * Gibt die PDFdateien eines Produktes zurÃŒck
-     */
-    public function getFiles($produkt_id)
-    {
-
-        $produkt_id = $this->shop->getProduktID($produkt_id);
-
-        $path = $this->getPDFPath($produkt_id);
-
-        if (!file_exists($path)) return;
-
-        $arrFiles = scandir($path);
-        $arPDFFiles = array();
-
-        foreach ($arrFiles as $file)
-        {
-
-            if (is_file($path.$file) && in_array(strtolower(preg_replace('/(.*)\./', '', $file)), $this->valid_ending))
-            {
-
-                $arPDFFiles[] = $file;
-
-            }
-
-        }
-
-        return $arPDFFiles;
-
-    } // private function getFiles($produkt_id)
-
-    /**
-     * Gibt alle Dokumente zurÃŒck, die zu einer Bestellung individualisiert wurden
-     */
-    public function getIndivFiles($produkt_id, $order_id)
-    {
-
-        $produkt_id = $this->shop->getProduktID($produkt_id);
-
-        $arFilesProdukt = $this->getFiles($produkt_id);
-        $arFilesReturn = array();
-
-        foreach ($arFilesProdukt as $k => $v)
-        {
-
-            $indiv = $this->db->fetchRow("SELECT * FROM `".WPSG_TBL_PDFINDIV."` WHERE `o_id` = '".wpsg_q($order_id)."' AND `file` = '".wpsg_q($v)."'");
-
-            $infoArray = array(
-                'done' => '0000-00-00 00:00:00',
-                'scheduled' => '0000-00-00 00:00:00',
-                'counter' => -1,
-                'status' => 0
-            );
-
-            if ($indiv['id'] > 0)
-            {
-
-                $infoArray['status'] = 1;
-                $infoArray['done'] = $indiv['done'];
-                $infoArray['scheduled'] = $indiv['scheduled'];
-                $infoArray['counter'] = $indiv['counter'];
-                $infoArray['indiv_id'] = $indiv['id'];
-                $infoArray['hash'] = $this->makeHash($indiv['id']);
-
-            }
-
-            if (@strtotime($indiv['done']) > 0) $infoArray['status'] = 2;
-
-            $infoArray['file'] = $v;
-            $infoArray['file_out'] = @$indiv['out_file'];
-            $infoArray['path'] = $this->getPDFIndivPath($order_id);
-
-            $arFilesReturn[] = $infoArray;
-
-        }
-
-        return $arFilesReturn;
-
-    } // public function getIndivFiles($produkt_id, $order_id)
-
-    /**
-     * ÃberprÃŒft ein Produkt ob es ein PDFDownloadProdukt ist
-     */
-    public function isPDFProdukt($produkt_key)
-    {
-
-        $produkt_id = $this->shop->getProduktId($produkt_key);
-
-        $arPDFs = $this->getFiles($produkt_id);
-
-        if (sizeof($arPDFs) > 0) return true;
-
-        return false;
-
-    } // private function isPDFProdukt($produkt_key)
-
-    /**
-     * Gibt den Pfad zu dem Ordner zurÃŒck in dem die PDFs abgelegt werden
-     */
-    public function getPDFPath($produkt_id)
-    {
-
-        if ($this->shop->get_option('wpsg_mod_downloadplus_pdfpath') !== false && trim($this->shop->get_option('wpsg_mod_downloadplus_pdfpath')) != '')
-        {
-
-            $path = $this->shop->get_option('wpsg_mod_downloadplus_pdfpath').'/'.$produkt_id.'/';
-
-        }
-        else
-        {
-
-            if ($this->shop->isMultiBlog())
-            {
-
-                $path = WP_CONTENT_DIR.'/'.WPSG_MB_UPLOADS.'/wpsg/wpsg_pdfprodukte/'.$produkt_id.'/';
-
-            }
-            else
-            {
-
-                $path = WP_CONTENT_DIR.'/uploads/wpsg/wpsg_pdfprodukte/'.$produkt_id.'/';
-
-            }
-
-        }
-
-        $this->shop->protectDirectory($path);
-
-        return $path;
-
-    } // public function getPDFPath($produkt_id)
-
-    /**
-     * Gibt den Pfad zurÃŒck wo die Individualisierten PDFs einer Bestellung liegen
-     */
-    public function getPDFIndivPath($order_id)
-    {
-
-        if ($this->shop->get_option('wpsg_mod_downloadplus_pdfindivpath') !== false && trim($this->shop->get_option('wpsg_mod_downloadplus_pdfindivpath')) != '') {
-
-            $path = $this->shop->get_option('wpsg_mod_downloadplus_pdfindivpath').'/'.$order_id.'/';
-
-        } else {
-
-            if ($this->shop->isMultiBlog()) {
-
-                $path = WP_CONTENT_DIR.'/'.WPSG_MB_UPLOADS.'/wpsg/wpsg_pdfprodukte_order/'.$order_id.'/';
-
-            } else {
-
-                $path = WP_CONTENT_DIR.'/uploads/wpsg/wpsg_pdfprodukte_order/'.$order_id.'/';
-
-            }
-
-        }
-        
-        $this->shop->protectDirectory($path);
-
-        return $path;
-
-    } // public function getPDFIndivPath($order_id)
-
-    /**
-     * Gibt die DownloadNr zurÃŒck
-     * @param int $order_id BestellID
-     * @param varchar $product_key Produktkey
-     */
-    private function getDownloadNr($order_id, $product_key, $product_index)
-    {
-
-        $product_id = $this->shop->getProduktID($product_key);
-
-        $format = $this->shop->get_option('wpsg_mod_downloadplus_numberformat');
-        if (!wpsg_isSizedString($format)) $format = "%download_nr%";
-
-        $download_nr = $this->shop->get_option('wpsg_mod_downloadplus_startnumber');
-        if (!wpsg_isSizedInt($download_nr)) $download_nr = 1;
-
-        $arCustomReplace = array(
-            '/\%download_nr\%/i' => $download_nr
-        );
-
-        $format = $this->shop->replaceUniversalPlatzhalter($format, $order_id, false, false, $product_id, $arCustomReplace, $product_index);
-
-        $this->shop->update_option('wpsg_mod_downloadplus_startnumber', $download_nr + 1);
-
-        return $format;
-
-    } // private function getDownloadNr($order_id, $product_key)
-
-} // class wpsg_mod_downloadplus extends wpsg_mod_basic
-
+			array_walk($arTemplates, function(&$e) {
+
+				$e['id'] = intval($e['id']);
+		        $e['defaulttemplate'] = intval($e['defaulttemplate']) > 0;
+		        $e['arField'] = $this->getTemplateFields($e['id']);
+
+		        $e['file'] = null;
+
+		        $path = $this->getPDFTemplatePath($e['id']);
+		        $arFiles = scandir($path);
+
+		        foreach ($arFiles as $f) {
+
+		        	if (preg_match('/\.pdf$/', $f)) {
+
+		        		$e['file'] = $f;
+
+			        }
+
+		        }
+
+		        $e['file_data'] = null;
+		        $e['file_delete'] = false;
+
+			});
+
+			return $arTemplates;
+
+		}
+
+		public function getTemplateIdFromProduct($product_key) {
+
+			$product_id = $this->shop->getProduktID($product_key);
+			$oProduct = wpsg_product::getInstance($product_id);
+
+			$product_template = intval($oProduct->getMeta('mod_downloadplus_template'));
+
+			if ($product_template <= 0) {
+
+				// Standard Template
+				$template_id = intval($this->db->fetchOne("SELECT `id` FROM `".WPSG_TBL_DP_TEMPLATES."` WHERE `defaulttemplate` = '1' "));
+
+			} else $template_id = $product_template;
+
+			if ($this->shop->hasMod('wpsg_mod_productvariants') && $this->shop->callMod('wpsg_mod_productvariants', 'isVariantsProductKey', [$product_key])) {
+
+				$arVarSet = $this->shop->callMod('wpsg_mod_productvariants', 'getSetVariArray', [$product_key]);
+
+				$vari_template = json_decode($oProduct->getMeta('mod_downloadplus_vari_template'), true);
+
+				if (wpsg_isSizedArray($vari_template)) {
+
+					foreach ($arVarSet as $var_id => $vari_id) {
+
+						if (wpsg_isSizedInt($vari_template[$var_id.'_'.$vari_id])) $template_id = $vari_template[$var_id.'_'.$vari_id];
+
+					}
+
+				}
+
+			}
+
+			return $template_id;
+
+		}
+
+		public function getTemplateFields($template_id = false) {
+
+	    	if ($template_id === false) $template_id = $this->db->fetchOne("SELECT `id` FROM `".WPSG_TBL_DP_TEMPLATES."` WHERE `defaulttemplate` = '1' ");
+
+	    	$template_id = intval($template_id);
+
+	    	if ($template_id > 0) {
+
+	    		$arField = $this->db->fetchAssoc("SELECT * FROM `".WPSG_TBL_DP_TEMPLATES_FIELD."` WHERE `template_id` = '".wpsg_q($template_id)."' ");
+
+	    		array_walk($arField, function(&$e) {
+
+	    			$e['id'] = intval($e['id']);
+					$e['x'] = intval($e['x']);
+					$e['y'] = intval($e['y']);
+					$e['align'] = intval($e['align']) > 0;
+					$e['bg'] = intval($e['bg']) > 0;
+					$e['alpha'] = wpsg_ff(wpsg_tf($e['alpha']));
+					$e['angle'] = intval($e['angle']);
+					$e['fontsize'] = intval($e['fontsize']);
+					$e['aktiv'] = intval($e['aktiv']) > 0;
+
+			    });
+
+	    		return $arField;
+
+		    } else return [];
+
+		}
+
+	} // class wpsg_mod_downloadplus extends wpsg_mod_basic
+
